#include <windows.h>
#include "exports.h"
#include "cwstart.h"


LIBMAIN


/* When this DLL is first loaded either by LibPreLoad() or LibAutoLoad(),
 * the function _init() is invoked.  Within this function, all DLL specific
 * initialization should be performed such as:
 *
 *         - Defining any module global keystrokes or keymaps to be used
 *         - Exporting any functions to be accessed through LibFunctionExec()
 *         - Autoloading any other DLLs.
 *
 */
void DLL 
_init()
{
	/* Place all 'LibExport' calls here.
	 */
	LibExport( "GrepMerge LPSTR" );
}

void DLL
GrepMerge( LPSTR fname )
{
	HBUFFER curBuf = BufQCurrentBuffer();
	HBUFFER newBuf;
	long    lastLine;
	long    lastCol;
	BOOL    doCopy  = TRUE;
	HBUFFER lastBuf;
	HBUFFER hBuffer;

	/* Determine a filename */
	fname = (ArgCount() && fname && *fname) ? fname : "grepout";

	if (BufEditFile( fname ))
	{
		BufClear();                      /* Start with an empty buffer */
		MovAbs( 1, 1 );
		newBuf = BufQCurrentBuffer();    /* Save appended buffer       */
		WinUpdate();                     /* Display the buffer         */
		BufSetCurrentBuffer( curBuf );   /* Restore current buffer     */
		WinUpdate();                     /* Display it.                */

		SysWaitStart();

		while (TRUE)
		{
			/* Assume that we are at the first matched FGrep pattern.
			 */
			if (doCopy)
			{
				MarkSavePos();                         /* Save original location  */
				MarkBeginSel( SELECTION_INCLUSIVE );   /* Begin selection         */
				MovEOF();                              /* Move to the end of file */
				MovEOL();
				BufCopyToScrap();                      /* Copy selection to scrap */
				MarkRestorePos();                      /* Restore position        */
	
				hBuffer = BufQCurrentBuffer();         /* Save current buffer     */
				BufSwitchBuffer( newBuf );             /* Switch to our buffer    */
				BufInsertScrap();                      /* Insert the scrap        */
				MovEOF();                              /* Append a newline        */
				MovEOL();                              /*    separator between    */
				BufInsertStr( "\n----GREP----\n" );                  /*    blocks.              */
				BufSwitchBuffer( hBuffer );            /* Back to original buffer */
			}

			lastLine = BufQCurrentLine();
			lastCol  = BufQCurrentCol();
			lastBuf  = BufQCurrentBuffer();
			LibFunctionExec( "FGrepNext" );        /* Next matched pattern    */

			/* If the buffer, line, and column don't change, we'll
			 * assume we're done.
			 */
			if (lastBuf == BufQCurrentBuffer())
			{
				if ((lastLine == BufQCurrentLine())
						&& (lastCol == BufQCurrentCol()))
					break;
				/* Else -- we've already copied this buffer */
				doCopy = FALSE;
				continue;
			}

			doCopy = TRUE;

			/* Just in case we get into an infinite loop... */
			if (KeyQPressed())
				if (KeyGetVKey() == 0x2103)  /* Check for Ctrl-Break */
					break;
		}
		SysWaitEnd();
		WinUpdate();
		BufSetCurrentBuffer( newBuf );
		WinUpdate();
	}
}


